#include "ENG_Pixel.h"

#define unint unsigned int
#define unchar unsigned char
// ͼ
#define glcd_XMAX 128
#define glcd_XMIN 0
#define glcd_YMAX 64
#define glcd_YMIN 0

//˿
#define LCD_RD  BIT0
#define LCD_WR  BIT2
#define LCD_A0  BIT6
#define LCD_CS  BIT1
#define LCD_RST BIT3
#define LCD_C_PORT P3OUT
#define LCD_D_PORT P4OUT
#define LCD_C_DIR  P3DIR
#define LCD_D_DIR  P4DIR
#define LCD_D_DIN  P4IN
#define LCD_RD_L LCD_C_PORT &=~LCD_RD
#define LCD_RD_H LCD_C_PORT |= LCD_RD
#define LCD_WR_L LCD_C_PORT &=~LCD_WR
#define LCD_WR_H LCD_C_PORT |= LCD_WR
#define LCD_A0_L LCD_C_PORT &=~LCD_A0
#define LCD_A0_H LCD_C_PORT |= LCD_A0
#define LCD_CS_L LCD_C_PORT &=~LCD_CS
#define LCD_CS_H LCD_C_PORT |= LCD_CS
#define LCD_RST_L LCD_C_PORT &=~LCD_RST
#define LCD_RST_H LCD_C_PORT |= LCD_RST

void Delayx(int t)
{
   unint i,j;
   for(i=0;i<t;i++)
      for(j=0;j<10;j++)   ;

}

void delay1(void)
{
    unchar j;
    for (j = 0;j <0xff;j++);
}






/******************************************************************************************
*     lcdwaitidle
*     
******************************************************************************************/
void lcdwaitidle(void)
{  
    LCD_D_PORT = 0xff;
   	LCD_A0_L;
   	LCD_CS_L;
   	LCD_RD_L;
   	LCD_D_DIR=0;
   	while((LCD_D_DIN&0x80)==0x80);
   	LCD_D_DIR=0xff;
   	LCD_RD_H;
   	LCD_CS_H;
}


/******************************************************************************************
*     lcdwrcommand
*     
******************************************************************************************/
void lcdwrcommand(unchar cmdcode)
{  
		lcdwaitidle();
   	 LCD_D_PORT = cmdcode;
   	 LCD_A0_L;
  	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	LCD_CS_L;
   	LCD_WR_L;
   	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	LCD_WR_H;
   	LCD_CS_H;
}




/******************************************************************************************
*     lcdwrdata
*     
******************************************************************************************/
void lcdwrdata(unchar dispdata)
{  
	lcdwaitidle();
   	LCD_D_PORT = dispdata;
   	LCD_A0_H;
   	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	LCD_CS_L;
   	LCD_WR_L;
   	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	_NOP();
   	LCD_WR_H;
   	LCD_CS_H;
}

//õַ
void glcd_set_address(unchar x,unchar y)
{
  if( (x>7) || (y>127) )return;
        lcdwrcommand(x+0xb0);    //дҳַ
        lcdwrcommand((y>>4)+0x10);   //дʼеַ
        lcdwrcommand(0x0f&y);     
}


/******************************************************************************************
*     lcdclear
*     
******************************************************************************************/
void lcdclear(unchar dat1)/*дݵLCDȫ  0x00  0x00  */
{
  int index1,index2;
    for(index1 = 0xb0;index1<0xb8;index1++)
    { 
        lcdwrcommand(index1);    //дҳַ
        lcdwrcommand(0x10);   //дʼеַ
        lcdwrcommand(0x00);
        for(index2 = 0x00;index2<128;index2++)
        {
            lcdwrdata(dat1); //дʾ
        }
    }
}



/******************************************************************************************
*     initlcm
*     
******************************************************************************************/
void initlcm(void)   
{    

//////////////////////////////////////////////////////////////////////
LCD_C_DIR  |=  0xff ;
LCD_D_DIR  |= 0xff;
LCD_C_PORT |=  0xff;
LCD_D_PORT |= 0xff;
//////////////////////////////////////////////////////////////////////
    LCD_RST_L; //Ӳλ
    delay1();
    LCD_RST_H;
    lcdwrcommand(0xe2); /*λ*/
    delay1();
    lcdwrcommand(0xa2); /*LCD BIAS=1/9*/
    lcdwrcommand(0xa0); /*еַƶ:ADC=0(SEG1->SEG132)*/
    lcdwrcommand(0xc0); /*ɨ跽:SHL=1(COM64->COM1)*/
    delay1();
//   lcdwrcommand(0xa3); //趨LCDռձΪ1/9 

    lcdwrcommand(0x2f); /*ԴģʽVC,VR,VF=111*/
    delay1();
    lcdwrcommand(0x26); /*ڲʣR2,R1,R0=111*/
    delay1();
    lcdwrcommand(0x81); /*ԱȶȼĴģʽ*/
    lcdwrcommand(0x16); /*ԱȶȼĴֵ  ޸ֵͿԵڶԱȶ   */
    lcdwrcommand(0x40); /*ʼ*/
    lcdwrcommand(0xe0); /*дʱеַԶ1ʱ*/
    lcdwrcommand(0xaf); /*ʾ*/
     lcdclear(0x00); 
}


/******************************************************************************************
*     dis_num
*     
******************************************************************************************/
void dis_char(int x,int y,unchar dat)
{
unsigned char itemp;
 if( (x>7) || (y>21) )return;
dat -= 32;
glcd_set_address(x,y*6);
for (itemp=0;itemp<6;itemp++)
lcdwrdata(font6x8[dat][itemp]);
}


   
/******************************************************************************************
*     lcd_draw
*     12λΪ31ݻ
******************************************************************************************/
void lcd_draw(int y, int data0 , int data1)
{
  int x0,x1;
     x0=7-data0/512;
     x1=7-data1/512;
  data0 = (data0/64)%8;
  switch(data0)
  {
    case 0:  data0=0x80;break;
    case 1:  data0=0x40;break;
    case 2:  data0=0x20;break;
    case 3:  data0=0x10;break;
    case 4:  data0=0x08;break;
    case 5:  data0=0x04;break;
    case 6:  data0=0x02;break;
    case 7:  data0=0x01;break;
   default:  break;
  }
    data1 = (data1/64)%8;
  switch(data1)
  {
    case 0:  data1=0x80;break;
    case 1:  data1=0x40;break;
    case 2:  data1=0x20;break;
    case 3:  data1=0x10;break;
    case 4:  data1=0x08;break;
    case 5:  data1=0x04;break;
    case 6:  data1=0x02;break;
    case 7:  data1=0x01;break;
   default:  break;
  }
  if(x0==x1)
   {
     data0=data0|data1;
     glcd_set_address(x0,y);
     if(x0==4)data0=data0|0x01;
     lcdwrdata((unchar)data0);
   }
   else
   { 
     glcd_set_address(x0,y);
     if(x0==4)data0=data0|0x01;
     lcdwrdata((unchar)data0);
     glcd_set_address(x1,y);
     if(x1==4)data1=data1|0x01;
     lcdwrdata((unchar)data1);
   }
}


/******************************************************************************************
*     lcd_wave
*     һ
******************************************************************************************/
void lcd_wave(int num,int *data0,int *data1)
{
  int a,b;
  b=num; 
for(a=0;a<127;a++)
   {
     data1[a++]=0x00;
   }

for(a=0;a<127;a++)
   {
     glcd_set_address(4,a);
     lcdwrdata(0x01);
   }
for(a=0;a<b;)
{
  lcd_draw(a++,*data0,*data1);
  data0++;
  data1++;
}
 for(a=0;a<8;a++)
   {
     glcd_set_address(a,0);
     lcdwrdata(0xff);
   }
}



/******************************************************************************************
*     DisplayListChar
*     ʾһַ
******************************************************************************************/
void DisplayListChar(int x, int y, char *DData)
{
  unchar ListLength;
  
  while(y>20)
  {
    x++;
    y=y-20;
  }
   if (x>7) return;
  ListLength=0;
while (DData[ListLength]>=0x20) //
  {
     dis_char(x, y, DData[ListLength]); //ʾַ
     ListLength++;
     y++;
     if(y>20){x++;  y=0;}
     if (x>7) return;
  }
  
}

