/*******************************************************************************/
//#define CPU_F ((double)8000000)
//#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
//#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))
/* Includes ------------------------------------------------------------------*/
#include <msp430x14x.h>
/*Define-------------------------------------------------------------*/
#define unint  unsigned int
#define unchar unsigned char
#define unlong unsigned long
#define FREQ_BASE 2000168000              //when using xt2   this value is 8M   У׼ֵ


/*ȫֱ-------------------------------------------------------------*/
unlong Freq;                                //Ƶ
unint  Freq_cap[2];                         //Ĵ
unint  Cap_index;                           //־
unint  Phasic[2];                              //λ  
int Ad_value_i[135],Ad_value_u[135];      //adĴ   ԭʼźżĴ  10k
int Num_i,Num_u;                            //ĸ         F=50Hzʱ   ĿΪ200
int Adc_busy;                               //adĴ״̬־   ־Ϊ0˵Բ 
                                            //                   ־Ϊ1˵ڲ  
                                            //                   ־Ϊ2˵  
                                            //                   ־Ϊ3˵ڴ   Ϻ0  صʼ

unint I_value,U_value,S_VA;
int P_W,PF_n,Q_Var;
unint I_value_max,U_value_max,S_VA_max;
int P_W_max,Q_Var_max;
unint I_value_min,U_value_min,S_VA_min;
int P_W_min,Q_Var_min;
int Max_Min[4];
int Dis_mod,First_dis0,First_dis1,First_dis2,Fft_mod;
/* Private functions -----------------------------------------------------*/
void Init_system(void);                     //ʼϵͳ   ȫֱ
void Init_sysclk(void);                     //ʼϵͳʱ
void Init_TATB(void);                       //ʼʱA  ʱB
void Init_adc12(void);                      //ʼad    
unlong get_focus(void);                     //Ƶ
unint get_phasic(void);                     //λ
void dis_first(void);
void  delay_ms(int i);                        //delay
#include"F:\iar3\new\calc.c"
#include"F:\iar3\new\display.c"


/*******************************************************************************
* Function Name  : main
* Description    : Main program
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main(void)
{

  WDTCTL = WDTPW + WDTHOLD;                 // Stop watchdog timer
  Init_system();
   _BIS_SR(GIE);                           // Enable global ints
  while(1)
  {
    switch(Dis_mod)
       {
        case 0:    display_mode0();break;
        case 1:    display_mode1();break;
        case 2:    display_mode2();break;
        case 3:    display_mode3();break;
        default: break;
       }  
  }
}
//***************************************************************************************************************




//***************************************************************************************************************
//ʼϵͳ  ȫֱ
void Init_system(void)
{
Init_sysclk();                             //ʼϵͳʱ
Init_TATB();                               //ʼʱ
Init_adc12();                              //ʼadc_12
initlcm();                                 //ʼҺ
dis_first();                               //
Cap_index=0;                               //־λ
Adc_busy=0;                                //adԲ     ֱʼ
Num_i=0;                                   //λadֵ
Num_u=0;
Max_Min[0]=0;
Max_Min[1]=4096;
Max_Min[2]=0;
Max_Min[3]=4096;
S_VA_max=0;
P_W_max=-32765;
Q_Var_max=-32765;
S_VA_min=65535;
P_W_min=32765;
Q_Var_min=32765;
Dis_mod=0;
First_dis0=0;
First_dis1=0;
First_dis2=0;
Fft_mod=0;
}



/*******************************************************************************
* Function Name  : TimerA0       Ƶʺλ
* Description    : ISR                жϷ     0.02s   20msжһ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
#pragma vector = TIMERA0_VECTOR
__interrupt void TimerA0(void)
{
 if(Cap_index==0)                           //һβ
     { 
      if(Adc_busy==0)                       //Բ 
         { 
            Adc_busy=1;                     //adڲ     ֱ
            Num_i=0;                        //λadֵ
            Num_u=0;
            TBCCR0= (Freq_cap[1]-Freq_cap[0])/128;
            TBCTL = TBSSEL_2 + MC_1;        // SMCLK,ʱBԴadв
            ADC12IE = 0x01;                           // Enable ADC12IFG.0
         }
    Freq_cap[Cap_index++]=TACCR0;           //沶ֵ
   }
  else if(Cap_index==1)                     //ڶβ
         { 
           if(Adc_busy==1)                  //ȴ 
             {
              ADC12IE = 0x00;                           // Disable ADC12IFG.0
              TBCTL = TBSSEL_2 + MC_0;      // SMCLK,ֹͣʱB    ֹad
              Adc_busy=2;                   //adϱ־  ȴ
             }       
           Freq_cap[Cap_index++]=TACCR0;           //沶ֵ
           Phasic[0]=TACCR1;                          //ȡCCR1ֵ   λ
         }
}

/*******************************************************************************
* Function Name  : ADC12ISR
* Description    : isr                adʱ  0.0001s   100usжһ
                                      ÿתжϺȡұadֵ   135
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
#pragma vector=ADC12_VECTOR
__interrupt void ADC12ISR (void)
{
  if(Adc_busy==1)                       //Բ 
  {
   Ad_value_i[(Num_i++)&0x7f]=ADC12MEM0 ;
   Ad_value_u[(Num_u++)&0x7f]=ADC12MEM1 ;
  }
   ADC12IFG=0;
}

// Common ISR for P2 Module
#pragma vector=PORT2_VECTOR
__interrupt void KEY_ISR(void)
{
 unsigned char i;
 P2IE &= 0xf0;        //disable P2.0~P2.3 interrupt
 i=P2IFG;
  delay_ms(5);
 if((P2IN&0x0f)!=0x0f)
 {
   if(i==BIT0){Dis_mod=0;First_dis1=1;First_dis2=1;}
   else if(i==BIT1){Dis_mod=1;First_dis0=1;First_dis1=1;First_dis2=1;}
   else if(i==BIT2){Dis_mod=2;First_dis0=1;First_dis2=1;}
   else if(i==BIT3){Dis_mod=3;First_dis0=1;First_dis1=1;First_dis2=1;Fft_mod++;if(Fft_mod>3)Fft_mod=0;}
 }
 P2IE |= 0x0f;        //enable P2.0~P2.3 interrupt
 P2IFG=0;
}


//***************************************************************************************************************
//ʼϵͳʱ      MCLK=SMCLK=XT2=8M
//ʼ˿          P5.4--P5.6    ϵͳʱ
void Init_sysclk(void)
{
  int i;
  BCSCTL1 &= ~XT2OFF;                       // XT2= HF XTAL =8M
  do
  {
  IFG1 &= ~OFIFG;                           // Clear OSCFault flag
  for (i = 0xFF; i > 0; i--);               // Time for flag to set
  }
  while ((IFG1 & OFIFG));                   // OSCFault flag still set?
  BCSCTL2 |= SELM_2+SELS;                        // SMCLK= MCLK= LFXT1 (safe) 
  P5SEL |=BIT4+BIT5+BIT6;                        //ϵͳʱ    У׼ʱ
  P2IE|=0x0f;
  P2IES|=0x0f;
}



//***************************************************************************************************************
//ʼʱ    
// ʱAƵΪSMCLK/4=2M             
//ʼ˿   ѡP1.1  P1.2  Ϊ˿   ԲѹƵʺλ
//Ϊѹ͵Ƶ  ѡѹΪ׼Ƶʺλ
//ز  

// ʱBƵΪSMCLK=8M        
//ʱBΪadĴԴ    ƵΪ6.4k
void Init_TATB(void)
{
  TACCTL0 = CM_1 + SCS + CCIS_0 + CAP + CCIE; // Rising edge + CCI0A (P1.1) + Capture Mode + Interrupt     ѹ
  TACCTL1 = CM_1 + SCS + CCIS_0 +CAP ;        // Rising edge + CCI1A (P1.2)+ Capture Mode  ж
  TACTL |=TACLR;                              //TACTlֵ            
  TACTL = TASSEL_2 + MC_2 +ID_2;              // SMCLK/4 = 2M Hz +  Continuous Mode
  P1SEL |= BIT1+BIT2;                         //select as  TA capture   CCIA0  CCIA1  
  TBCCTL0 = OUTMOD_4;                        // Toggle on EQU1 (TAR = 0) 
  TBCTL = TBSSEL_2 + MC_0;                   // SMCLK, stop mode
  TBCCR0= 312-1;
}


//***************************************************************************************************************
//ʼad     ͨת     TB0½شֹͣ     
//תͨA0  A1   
//   ݶ   10k       
//TBOUT0     
// ADC12CLK=5M          ʱtsample=4*ADC12CLK*4 =3.2us  
//תʱ       tADC=tsample+    ADC12CLK*13  = 5.8us
void Init_adc12(void)  
{
  ADC12CTL1 = SHS_2 + SHP + CONSEQ_3;       // TA trig., rpt conv.
  ADC12MCTL0 = SREF_2 + INCH_0;            // Channel A10, Vref+
  ADC12MCTL1 = SREF_2 + INCH_1 + EOS;            // Channel A10, Vref+
  ADC12IE = 0x01;                           // Enable ADC12IFG.0
  ADC12CTL0 = SHT0_2 + ADC12ON + ENC; // Config ADC12
}


//***************************************************************************************************************
//Ƶ                   
//Ƶ      xx.xxxx
unlong get_focus(void)
{
static int flag_sum=0;
static unlong sum_freq=0;
static unlong sig_freq=0;
unsigned int psc;
unlong cc;
     if(Cap_index==2)
        {
          sig_freq=FREQ_BASE/(Freq_cap[1]-Freq_cap[0]);   
          psc=Freq_cap[1]-Phasic[0];                        
          cc=(unlong)psc*360;
          Phasic[1]=(unsigned int)(cc/(unsigned long)(Freq_cap[1]-Freq_cap[0]));
        if((sig_freq>44000)&&(sig_freq<56000))               // 56HzС44Hz򶪵
          {
            sum_freq=sum_freq+sig_freq+1;                      //ÿõĽۼ  1ΪУ׼
             flag_sum++;
             if(flag_sum>9)                                    //жǷ񵽴10
             {
              Freq=sum_freq/10;                                //ȡƽֵ
              flag_sum=0;                                      //͸
              sum_freq=0;                                      
              Cap_index=0;                                     //λɱ־
              return(Freq);                                    //Ƶֵ
             }
          }
             Cap_index=0;                                      //λɱ־
           return(0);
        }
     else return(0);
}



//***************************************************************************************************************
//ʾ                 
//
void dis_first(void)
{
  DisplayListChar(3,3,"Init system...");               
  delay_ms(2000);                                    //ȴϵͳȶ
  DisplayListChar(3,0,"                    ");  
  DisplayListChar(0,6,"F:      0 Hz");
  DisplayListChar(1,6,"U:      0 V");
  DisplayListChar(2,6,"I:      0 A");
  DisplayListChar(3,6,"P:      0 W");
  DisplayListChar(4,6,"Q:      0 Var");
  DisplayListChar(5,6,"S:      0 VA");
  DisplayListChar(6,5,"PF:      0");
}


void delay_ms(int i)
{	
int a;
	for(;i>0;i--)
	 {
	 	for(a=0;a<1000;a++);
	 }
}



